#!/usr/bin/perl

# Mensa-Speisplan fr den Palm-Handheld (und plucker)

use LWP::Simple ();
use HTML::TableExtract;
use strict;


my $kwTableUrl = "http://www.uni-siegen.de/others/stw/Mensa.htm";
# test $kwTableUrl = "Mensa.htm";
my $kwBaseUrl = "http://www.uni-siegen.de/others/stw/";

# Tabelle mit Kalenderwochen-Links holen und auswerten:
# jetzt lokal, spaeter mit LWP usw.:
#open( KWT, "<" . $kwTableUrl ) || die "Keine Datei mit KW-Tabelle.\n";
#my $kwData = join( '', <KWT> );
#close( KWT );

my $kwData = LWP::Simple::get( $kwTableUrl ) or die "Konnte $kwTableUrl nicht holen!";


my @datums;  my $datumNum = 0;
my @links;   my $linkNum  = 0;

my $fund;

# Extrahieren der Link-berschriften:
while ($kwData =~ /(\d\d\.\d\d\.[^<]+)/g) {
  $fund = $1;
  $fund =~ s/\r\n//g;
  $fund =~ s/\ +/\ /g;
  $fund =~ s/\&nbsp;//g;
# print "$fund\n";
  $datums[$datumNum] = $fund;
  $datumNum++;
}

# Extrahieren der Links:
while ($kwData =~ /<a href="([^"]+)"[^>]+>([^<]+)<\/a/g) {
  $fund = $1;
# print "$fund\n";
  $links[$linkNum] = $kwBaseUrl . $fund;    # $links[$linkNum] = $fund;
  $linkNum++;
}

# print $datums[0] . " : " . $links[0] . "\n";
# print $datums[1] . " : " . $links[1] . "\n";
# print $datums[2] . " : " . $links[2] . "\n";
# print "\n\n\n";

print "<html><head><title>Mensa</title></head><body>\n";
print "<a name=\"top\"><h2>Speiseplan</h2></a>\n";
print "<a href=\"#0\">" . $datums[0] . "</a><br>\n";
print "<a href=\"#1\">" . $datums[1] . "</a><br>\n";
print "<a href=\"#2\">" . $datums[2] . "</a><br>\n";
print "<hr>\n";

# nun holen wir die einzeldokumente und basteln die um:
sub reformat {
  my ($str) = @_;
  $str =~ s/\&nbsp;<\/P>\n//g;
  $str =~ s/\ +/\ /g;
# $str =~ s/\n/<br>\n/g;
  return $str;
}

sub umlaute {
  my ($str) = @_;
  $str =~ s//&auml;/g;
  $str =~ s//&ouml;/g;
  $str =~ s//&uuml;/g;
  $str =~ s//&Auml;/g;
  $str =~ s//&Ouml;/g;
  $str =~ s//&Uuml;/g;
  $str =~ s//&szlig;/g;
  return $str;
}


my $src  = "";
my $html = "";

my ($tag, $beilagen, $menu2, $menu3, $eintopf);

for (my $i=0; $i <=2 ; $i++) {
  $src = $links[$i];

  $html = LWP::Simple::get( $src ) or die "Konnte Plan $src nicht holen!";
#  open( FILE, "<" . $src ) or die "pech, kann $src nicht ffnen.";
#  $html = join('', <FILE>);
#  close( FILE );

  print "<a name=\"$i\"><b>Woche " . $datums[$i] . ":</b></a><br>\n";

  my $te = new HTML::TableExtract();
  $te->parse( $html );

  my $rownum = -1;
  ROW: foreach my $row ($te->rows()) {
    $rownum++;
    next ROW if $rownum == 0;

    $tag      = $row->[0];
    $tag      =~ s/\ *\r\n//g;
    $tag      =~ s/^[^a-zA-Z]+//g;
    $beilagen = umlaute( reformat( $row->[1] ) );
    $menu2    = umlaute( $row->[4] );
    $menu3    = umlaute( $row->[6] );
    $eintopf  = umlaute( $row->[8] );

    print "<a href=\"#top\"><h2>$tag</h2></a>\n";
    print "<b>Beilagen: </b><br>\n<i>$beilagen</i><br>\n";
    print "<b>Menu 2:</b><br>\n$menu2<br>\n";
    print "<b>Menu 3:</b><br>\n$menu3<br>\n";
    print "<b>Eintopf:</b><br>\n$eintopf<br>\n";
    print "<hr>\n";
  }
}

print "</body></html>\n";
